



<!DOCTYPE html><html lang=zh-CN><head><meta http-equiv="Content-Type" content="text/html; charset=utf-8" /><meta http-equiv="X-UA-Compatible" content="IE=edge,chrome=1"><meta name="applicable-device" content="pc,mobile"><meta name="renderer" content="webkit"><meta name="viewport" content="width=device-width,initial-scale=1.0,maximum-scale=5,viewport-fit=cover">
<title>MySQL中JSON字段的使用技巧</title>	
<script src="//n4.ikafan.com/assets/run_prettify.js?ac"></script>
<link rel="stylesheet" href="//n4.ikafan.com/assetsg/style.css">
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/fontello.css?ac"> -->
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/animation.css?ac"> -->
<script>
var _hmt = _hmt || [];
(function() {
  var hm = document.createElement("script");
  hm.src = "https://hm.baidu.com/hm.js?c61d51e9fdcf1d1631ddfce8df9cd119";
  var s = document.getElementsByTagName("script")[0]; 
  s.parentNode.insertBefore(hm, s);
})();
</script>
<script src="https://n4.ikafan.com/g/show.js"></script>

</head>
<div id="header" class="navbar navbar-default navbar-fixed-top header-01">
	<div class="container">
		<h1 class="logo">
			<a  href="/" title="巴特西"/>
							巴特西
			</a>
		</h1>
				<div role="navigation"  class="site-nav  primary-menu">
			<div class="menu-fix-box">
				 <ul id="menu-navigation" class="menu" >
<li><a href="/">首页</a></li>
<!-- <li><a href="/search/Hadoop/">Hadoop</a></li>
<li><a href="/search/Linux/">Linux</a></li>
<li><a href="/search/jQuery/">jQuery</a></li> -->
<li><a href="/search/Python/">Python</a></li>
<li><a href="/search/Java/">Java</a></li>
<li><a href="/search/PHP/">PHP</a></li>
<li><a href="/search/IOS/">IOS</a></li>
<li><a href="/search/Andorid/">Andorid</a></li>
<li><a href="/search/NodeJS/">NodeJS</a></li>
<li><a href="/search/JavaScript/">JavaScript</a></li>
<li><a href="/search/HTML5/">HTML5</a></li>
				</ul>					 			
			</div>
		</div>
				<!--<div class="right-nav">
				<button class="js-toggle-search"><i class="icon-search"></i></button>
		</div>-->
       
			</div>	
</div>

<div id="page-content">
	<div class="container">
		<div class="row">
			
			<div class="blog-post">
								<!--<div class="posts-top-cjtz clearfix"></div>-->
								<div class="post">
										<div class="post-title">
											<div id="title_top"></div>
<script>insertAdIfNeeded();</script>
						<h1 class="title">MySQL中JSON字段的使用技巧</h1>
						<div class="post_icon">
							<span class="icon-clock-1"> 2024-02-03 15:37:58 </span>
						</div>
										<div class="post-content">
													<div id="single_top"></div>
<script>insertAdIfNeeded();</script>
											
		<div>
<p>mysql5.7.8之后开始原生支持json. 在类似mongodb这种nosql数据库中,json存储数据是非常自然的, 在mysql中合理的使用json,能够带来极大的便利</p>
<h4>Json字段的使用场景</h4>
<p>在读laravel手册举例子时,我们经常会看到 <code>$user-&gt;is_admin</code> 来判断用户是否为管理员,但是在用户表中,admin往往只占很小一部分.如果单开一个is_admin字段是很没有必要的行为.数据库中会有大量的无意义数据存储, 我们可以为user表创建一个 json 字段,来存储我们的is_admin字段</p>
<pre class="prettyprint linenums"><code>[<br />
    {<br />
        id: 1,<br />
        username: 'weiwenhao',<br />
        rest: { // 冗余字段<br />
            is_admin: 1<br />
        }<br />
    },<br />
    {<br />
        id: 2,<br />
        username: 'eienao',<br />
        rest: null<br />
    }<br />
]<br />
复制代码</code></pre>
<blockquote><p>当然即使不使用json,我们也不会使用is_admin来判断是否为管理员.</p>
<p>可以通过新增admin表或者RABC来标志管理员</p></blockquote>
<p>依旧是用户表, 很常见的一个需求是第三方登录,如果我们使直接在user表新增<code>facebook_id,facebook_email,facebook_phone_number,google_id,....</code>字段, 可以预见这会造成大量的无意义数据(即使他们不占用内存,或者影响性能)</p>
<blockquote><p>一种解决办法是 使用一对多关系来解决, 既建立一个 第三方登录表来存储第三方登录的id/email/phone_number等</p></blockquote>
<p>但是我更喜欢使用json字段来解决这个问题</p>
<pre class="prettyprint linenums"><code>[<br />
   {<br />
        id: 1,<br />
        username: 'weiwenhao',<br />
        rest: {<br />
            is_admin: 1,<br />
            facebook_id: 2348234,<br />
            facebook_phone_number: 2834723234,<br />
        }<br />
    },<br />
    {<br />
        id: 2,<br />
        username: 'eienao',<br />
        rest: {<br />
            google_id: 2348234,<br />
            google_email: xxx@gmail.com<br />
        }<br />
    }<br />
]<br />
复制代码</code></pre>
<p>可以看出,使用json字段使数据表的设计更加自然,集中,业务也相应的更加的简单方便.</p>
<h4>Json字段在laravel中的使用</h4>
<p>首先是迁移文件 <code>$table-&gt;json('rest')-&gt;nullable();</code></p>
<p>laravel对json的使用进行了一定的优化,对于更新和创建我们可以.</p>
<pre class="prettyprint linenums"><code>$user = new User;<br />
$user-&gt;{'rest-&gt;google_id'} = 'xxx';<br />
# 如果你的rest字段为null,那么上面的操作会使 null 会变成 {google_id: "xxx"}, 不需要再做 是否为null的判定啦<br />
# 如果仅使用上面的插入操作,也不需要在使用模型的修改器来吧 json =&gt; array, array =&gt; json啦<br />
复制代码</code></pre>
<blockquote><p>当rest字段的值为null时,批量操作无法执行, 类似 <code>update(['rest-&gt;google_id' =&gt; 'xxx'])</code> 这样的操作执行无效,因此更推荐上面的方式来进行更新操作</p></blockquote>
<p>对于查找操作可以方便的使用</p>
<p><code>User::where('rest-&gt;google_id','xxx')-&gt;firstOrFail()</code></p>
<blockquote><p>关于检索的效率问题,在后面内容中给出解决方案</p></blockquote>
<h4>Generated Column (生成列)</h4>
<p>5.7新增了生成列, 生成列的值是根据列定义中包含的表达式计算得来.官方示例:计算直角三角形的斜边的长度</p>
<pre class="prettyprint linenums"><code>CREATE TABLE triangle (<br />
  sidea DOUBLE,<br />
  sideb DOUBLE,<br />
  sidec DOUBLE AS (SQRT(sidea * sidea + sideb * sideb)) # AS (expression) 为生成列的核心语法<br />
);<br />
INSERT INTO triangle (sidea, sideb) VALUES(1,1),(3,4),(6,8);

# 对于上面的插入,查询可以得到如下结果

mysql&gt; SELECT * FROM triangle;<br />
+-------+-------+--------------------+<br />
| sidea | sideb | sidec              |<br />
+-------+-------+--------------------+<br />
|     1 |     1 | 1.4142135623730951 |<br />
|     3 |     4 |                  5 |<br />
|     6 |     8 |                 10 |<br />
+-------+-------+--------------------+<br />
复制代码</code></pre>
<p>上面的 sidec的值 是根据sidea和sideb计算得来, 并未实际的存储在磁盘中.mysql5.7之前我们想要实现上面的需求可能会这样写sql语句</p>
<pre class="prettyprint linenums"><code>SELECT *,(SQRT(sidea * sidea + sideb * sideb)) as sidec FROM triangle;<br />
复制代码</code></pre>
<p>上面既生成列的主要作用, 实际上生成列有两种子类型,上面的例子属于 virtual (虚拟) 类型的生成列, 其并没有将sidec的值实际存储在磁盘中.</p>
<p>除了virtual, 生成列还支持 stored类型,其创建语句为</p>
<pre class="prettyprint linenums"><code>#...<br />
sidec DOUBLE AS (SQRT(sidea * sidea + sideb * sideb)) STORED # stored不指定则默认为 virtual<br />
#...<br />
复制代码</code></pre>
<p>当行创建或者更新时, 会重新计算 sidec并将其存储在磁盘中</p>
<p>生成列的另一个重要的特性是可以根据<strong>生成列表达式的计算结果建立索引</strong>. 其建立索引的方式和普通字段创建索引的方式一致.1</p>
<pre class="prettyprint linenums"><code>CREATE TABLE triangle (<br />
  sidea DOUBLE,<br />
  sideb DOUBLE,<br />
  sidec DOUBLE AS (SQRT(sidea * sidea + sideb * sideb)) # AS (expression) 为生成列的核心语法<br />
  INDEX(`sidec`)<br />
);<br />
复制代码</code></pre>
<p>索引本身也是存储在磁盘中的实际存在的物质, 因此 virtual 生成列 + 索引,可以达到存储空间的最有效利用.</p>
<blockquote><p>对于stored 生成列 + 索引, 通常不会访问到存储在磁盘中stored 生成列,而是直接访问索引.因此没有必要使用stored生成列</p></blockquote>
<h4>使用生成列为json中的字段添加索引</h4>
<p>已user表的rest.google_id为例,建表操作</p>
<pre class="prettyprint linenums"><code>#...<br />
`rest` json NULL,<br />
# JSON_EXTRACT(`rest`,'$.google_id') 等价于 `rest`-&gt;'$.google_id'<br />
# 5.7.13版本后<br />
# JSON_UNQUOTE(JSON_EXTRACT(`rest`,'$.google_id')) 等价于 `rest`-&gt;&gt;'$.google_id'<br />
# 使用生成列为json添加索引时,请务必使用 JSON_UNQUOTE(JSON_EXTRACT(`rest`,'$.google_id'))/-&gt;&gt;<br />
`google_id` varchar GENERATED ALWAYS AS (`rest`-&gt;&gt;'$.google_id')) NULL<br />
UNIQUE INDEX(`google_id`)<br />
#...<br />
复制代码</code></pre>
<p>在laravel迁移文件中</p>
<pre class="prettyprint linenums"><code>$table-&gt;json('rest')-&gt;nullable();

$table-&gt;string('rest')-&gt;nullable()-&gt;unique()-&gt;virtualAs('`oauth`-&gt;&gt;"$.google_id"');<br />
复制代码</code></pre>
<p>有了索引后,当我们执行查询操作</p>
<pre class="prettyprint linenums"><code>select * from users where `rest`-&gt;'$.google_id' = 'xxx' # 通常使用这种更加简单的形式<br />
select * from users where `rest`-&gt;&gt;'$.google_id' = 'xxx'

# 上面两种表达式会被mysql的优化器在查询阶段自动优化为 select * from users where google_id = 'xxx'<br />
复制代码</code></pre>
<h4>一些补充</h4>
<ul><li><p><code>virtualAs(oauth-&gt;"$.google_id"');</code> 使用 **-&gt;**符号来创建生成列会出现无法使用索引的情况, 原因不是很明了,需要继续研究一下手册. 另外对于创建语句 <code>GENERATED ALWAYS</code>的作用也不是很明了.</p></li>
<li><p>关于null, 经常会看到一种言论是mysql中使用null作为字段默认值会出现无法索引的情况.但经过查询了解,发现这是一种老中医理论. 我更倾向于使用null作为默认值, 而不是 ''/0/0.0 ,我认为null的表达性更好, laravel中也无时无刻不在提现这种思想.</p></li>
<li><p>关于json的使用, 最近的项目中,我大部分核心表都有一个json字段,做一些非核心数据的存储和冗余. 比</p></li></ul>
</div>
<p>作者：weiwenhao<br />链接：https://juejin.im/post/5c1332625188251e663eb925</p>												<div id="single_bottom"></div>
<script>insertAdIfNeeded();</script>
																
<h2>最新文章</h2>	
<ol>
						<li><a href="https://www.batexi.com/a/o8kn0n68.html">C fgetc</a>
		</li>
						<li><a href="https://www.batexi.com/a/m8ze7g18.html">Swagger接入</a>
		</li>
						<li><a href="https://www.batexi.com/a/0qwe3k3q.html">Effective C&plus;&plus; -----条款02：尽量以const&comma; enum&comma; inline替换 &num;define</a>
		</li>
						<li><a href="https://www.batexi.com/a/9rd66e48.html">&lpar;转&rpar;基于Redis Sentinel的Redis集群&lpar;主从&amp;amp&semi;Sharding&rpar;高可用方案</a>
		</li>
						<li><a href="https://www.batexi.com/a/q4yxg6jq.html">vmware配置安装JDK、Tomcat以及项目部署</a>
		</li>
						<li><a href="https://www.batexi.com/a/93x0vxz9.html">ul li 好友列表</a>
		</li>
						<li><a href="https://www.batexi.com/a/qnj57x38.html">自然梯度（Natural Gradient）</a>
		</li>
						<li><a href="https://www.batexi.com/a/q4z65ne9.html">Elastic 技术栈之 Filebeat</a>
		</li>
						<li><a href="https://www.batexi.com/a/9ge036e8.html">iOS-UI控件优化</a>
		</li>
						<li><a href="https://www.batexi.com/a/9ge61208.html">bat脚本：Java一键编译&lpar;Javac java&rpar;</a>
		</li>
						<li><a href="https://www.batexi.com/a/qwvjngr8.html">hive on spark</a>
		</li>
						<li><a href="https://www.batexi.com/a/8kj2gp69.html">GO流程控制</a>
		</li>
						<li><a href="https://www.batexi.com/a/93w3md0q.html">&lbrack;转&rsqb;&lbrack;C&num;&rsqb;Linq 的扩展方法</a>
		</li>
						<li><a href="https://www.batexi.com/a/9gjrore9.html">ElasticSearch权威指南学习（索引管理）</a>
		</li>
						<li><a href="https://www.batexi.com/a/9gjkpl49.html">React-使用redux-immutable统一数据格式</a>
		</li>
						<li><a href="https://www.batexi.com/a/9gj6v449.html">synchronized和lock比较</a>
		</li>
						<li><a href="https://www.batexi.com/a/9gjyl5e9.html">项目发布脚本-nodejs</a>
		</li>
						<li><a href="https://www.batexi.com/a/qxdm30e9.html">【Python029--一个任务】</a>
		</li>
						<li><a href="https://www.batexi.com/a/960rn239.html">c&plus;&plus; shared&lowbar;ptr的使用</a>
		</li>
						<li><a href="https://www.batexi.com/a/95gee2mq.html">Xshell中文乱码怎么处理？</a>
		</li>
		</ol>
	

<h2>热门文章</h2>	
<ol>
									<li><a href="https://www.batexi.com/a/9jmdwk09.html">Python入门：条件控制</a>
			</li>
						<li><a href="https://www.batexi.com/a/9gprl5l9.html">jmeter 常用内置变量</a>
			</li>
						<li><a href="https://www.batexi.com/a/8korw7jq.html">php &dollar;&lowbar;SERVER&lbrack;&amp;&num;39&semi;HTTP&lowbar;USER&lowbar;AGENT&amp;&num;39&semi;&rsqb;  2</a>
			</li>
						<li><a href="https://www.batexi.com/a/8mjrg1o8.html">PHP 常用函数总结（一）</a>
			</li>
						<li><a href="https://www.batexi.com/a/93pg0wz8.html">&lbrack;转帖&rsqb;ssd固态硬盘的Trim命令是什么？</a>
			</li>
						<li><a href="https://www.batexi.com/a/963z6wn9.html">&period;NET 切面编程 PostSharp</a>
			</li>
						<li><a href="https://www.batexi.com/a/qdjx0pjq.html">es6 很简单</a>
			</li>
						<li><a href="https://www.batexi.com/a/8emx1kj9.html">【转载】JSP生成静态Html页面</a>
			</li>
						<li><a href="https://www.batexi.com/a/9634p539.html">Python 自动补全&lpar;vim&rpar;</a>
			</li>
						<li><a href="https://www.batexi.com/a/qx24kre8.html">一千个不用Null的理由</a>
			</li>
			</ol>			
							
					</div>

					
<div class="next-prev-posts clearfix">
</div>
						 
				</div>
				
	<div class="clear"></div>

			</div>	
			

		</div>
</div>
</div>


<div class="clearfix"></div>
<div id="footer" class="two-s-footer">
	<div class="footer-box">
		<div class="container">
			<div class="row" style="padding-left: 15px;padding-right: 15px;">
			<div class="nav-footer">
				<a href="/">Home</a>
				</div>
				<div class="copyright-footer">
					<p>Powered By WordPress</p>
				</div>
							</div>
		</div>
	</div>
</div>
<div style="display:none">

</div>
<script src="//n4.ikafan.com/assets/js/echo.js"></script>
<script>
    echo.init({
      offset: 100,
      throttle: 250,
      unload: false,
      callback: function (element, op) {
        console.log(element, 'has been', op + 'ed')
      }
    });
 </script>
</body>
</html>
